<template>
  <div v-if="loading" class="row py-2">
    <div class="col placeholder-wave">
      <span class="placeholder col-12 placeholder-lg rounded-3" />
    </div>
  </div>
  <div v-else class="form-floating">
    <select
      v-bind="$attrs"
      :id="props.id"
      v-model="value"
      :class="classes"
      :aria-label="props.label"
    >
      <option
        v-for="option in props.options"
        :key="option.value"
        :value="option.value"
        :disabled="option.disabled"
      >
        {{ option.label }}
      </option>
    </select>
    <label :for="props.id">
      {{ props.label }}<span v-if="required">*</span>
    </label>
    <div v-if="props.footnote" class="row">
      <div class="col d-flex justify-content-start">
        <p class="text-muted small pt-1">
          {{ footnote }}
        </p>
      </div>
    </div>
  </div>
</template>

<script setup>
import { computed } from "vue";

const emit = defineEmits(["update:modelValue", "change"]);

const props = defineProps({
  id: {
    type: String,
    required: false,
  },
  footnote: {
    type: String,
    required: false,
  },
  options: {
    type: Array,
    required: true,
  },
  size: {
    type: String,
    required: false,
    default: "md",
  },
  label: {
    type: String,
    required: false,
  },
  loading: {
    type: Boolean,
    required: false,
    default: false,
  },
  required: {
    type: Boolean,
    required: false,
    default: false,
  },
  modelValue: {
    type: [String, Number, Boolean],
    required: false,
  },
});

const classes = computed(() => {
  return ["form-select", `form-select-${props.size}`, ""];
});

const value = computed({
  get() {
    return props.modelValue;
  },
  set(event) {
    emit("update:modelValue", event);
    emit("change", event);
  },
});
</script>

<style>
.placeholder {
  font-size: 2rem;
}
</style>
